//------------------------------------------------------------------------------
// Ώۃ}CR R8C/34C
// ̧ٓe     Micon Racer Advance
// o[W   Ver.1.00
// Date         2014.12.19
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// CN[h
//------------------------------------------------------------------------------
#include "sfr_r834c.h"

//------------------------------------------------------------------------------
// V{`
//------------------------------------------------------------------------------
#define TIMER_CYCLE     155             // 1ms:0.001/(1/(20000000/128))-1

#define PWM_CYCLE       999             // 0.4ms:0.001/(1/(20000000/8))-1
//#define PWM_CYCLE       19999         // 8ms  :0.008/(1/(20000000/8))-1
//#define PWM_CYCLE       3999          // 1.6ms:0.0016/(1/(20000000/8))-1
//#define PWM_CYCLE       1999          // 0.8ms:0.0008/(1/(20000000/8))-1
//#define PWM_CYCLE       999           // 0.4ms:0.0004/(1/(20000000/8))-1
//#define PWM_CYCLE       499           // 0.2ms:0.0002/(1/(20000000/8))-1

#define Def_500Hz       4999            // 500Hz:(1/500)/(1/(20000000/8))-1
#define Def_1000Hz      2499            // 1000Hz:(1/1000)/(1/(20000000/8))-1

#define Def_C3          19083           // h:(1/131)/(1/(20000000/8))-1
#define Def_D3          17006           // :(1/147)/(1/(20000000/8))-1
#define Def_E3          15151           // ~:(1/165)/(1/(20000000/8))-1
#define Def_F3          14285           // t@:(1/175)/(1/(20000000/8))-1
#define Def_G3          12754           // \:(1/196)/(1/(20000000/8))-1
#define Def_A3          11362           // :(1/220)/(1/(20000000/8))-1
#define Def_B3          10120           // V:(1/247)/(1/(20000000/8))-1
#define Def_C4          9541            // h:(1/262)/(1/(20000000/8))-1

#define DI()            asm("FCLR I")   // 荞݋֎~
#define EI()            asm("FSET I")   // 荞݋

#define WHITE           (1)
#define BLACK           (0)

//------------------------------------------------------------------------------
// IvVݒ
//------------------------------------------------------------------------------

#define CENTER_LINE     BLACK						// C̐F̐ݒ

#define MOTOR_LIMIT		(60)						// [^őo : 60%
#define OPTION_L        (MOTOR_LIMIT)				// ő]ݒ
#define OPTION_R        (MOTOR_LIMIT)

// LEDZT[`  F   F_
#define SENSOR_LR0		(       0x04 | 0x02       )	//    : 
#define SENSOR_L1		(       0x04              )	// () : 
#define SENSOR_R1		(              0x02       )	// E() : 
#define SENSOR_L2		(0x08 | 0x04              )	// () : 
#define SENSOR_R2		(              0x02 | 0x01)	// E() : 
#define SENSOR_L3		(0x08                     )	// () : 
#define SENSOR_R3		(                     0x01)	// E() : 
#define SENSOR_AB		(0x08 | 0x04 | 0x02 | 0x01)	// S_ :  (AB:All Black)
#define SENSOR_AW		(0x00)						// S :  (AW:All White)

//------------------------------------------------------------------------------
// ֐vg^Cv̐錾
//------------------------------------------------------------------------------
void init( void );
unsigned char sensor( void );
unsigned char sensor_check( void );
void motor( int data1, int data2 );
void timer( unsigned long timer_set );
void beep( int data1 );
unsigned char pushsw( void );
void ctrl_servo( int degree );
void set_servo( int degree );
unsigned short get_adc(void);

//------------------------------------------------------------------------------
// O[oϐ̐錾
//------------------------------------------------------------------------------
unsigned long           cnt0 = 0;       // timer֐p
unsigned long           cnt1 = 0;       // mainŎgp
unsigned long           cnt2 = 0;       // R
unsigned long           cnt3 = 0;       // R
int                     pattern = 0;    // p^[ԍ
volatile static int		deg = 0;		// ڕWpx
volatile static unsigned char	line_data = 0;	// ŐVCp^[

//------------------------------------------------------------------------------
// CvO
//------------------------------------------------------------------------------
void main(void)
{
	unsigned char read_line = 0;
	
    init();		// Ӌ@\

	while( pushsw() == 0 );	// X^[g{^҂
    while(1){		
		
		read_line = sensor_check();		// CZT[ŐV擾
		switch(read_line){				// CZT[̍ŐVɉ̕
			case SENSOR_AW:				// CFȂ (R[XAEg)
				motor(0,0);				// [^~
				break;
			case SENSOR_LR0:			// CF (ԑ:)
				set_servo(0);			// ڕWpxF}0
				motor(100, 100);		// ֋쓮[^F100% | E100% (i)
				break;
			case SENSOR_L1:				// CF (ԑ:C菭EɈʒu)
				set_servo(-10);			// ڕWpxF-10(ɏȂ)
				motor(100, 100);		// ֋쓮[^F100% | E100% (i)
				break;
			case SENSOR_R1:				// CFE (ԑ:菭Ɉʒu)
				set_servo(10);			// ڕWpxF 10(EɏȂ)
				motor(100, 100);		// ֋쓮[^F100% | E100% (i)
				break;
			case SENSOR_L2:				// CF (ԑ:CEɈʒu)
				set_servo(-25);			// ڕWpxF-25(ɒ炢Ȃ)
				motor( 60,  100);		// ֋쓮[^F 60% | E100% (ɏȂ)
				break;
			case SENSOR_R2:				// CFE (ԑ:C荶Ɉʒu)
				set_servo(25);			// ڕWpxF 25(Eɒ炢Ȃ)
				motor( 100,  60);		// ֋쓮[^F100% | E 60% (EɏȂ)
				break;
			case SENSOR_L3:				// CF傫 (ԑ:C傫EɈʒu)
				set_servo(-40);			// ڕWpxF-40(ɑ傫Ȃ)
				motor( 33,  100);		// ֋쓮[^F 33% | E100% (ɑ傫Ȃ)
				while( sensor_check() != SENSOR_L2);	// Z^[COĂAA܂Ōێ쓮[^͒~Ȃ
				break;
			case SENSOR_R3:				// CF傫E (ԑ:C傫Ɉʒu)
				set_servo(40);			// ڕWpxF 40(Eɑ傫Ȃ)
				motor( 100,  33);		// ֋쓮[^FE100% | E 33% (Eɑ傫Ȃ)
				while( sensor_check() != SENSOR_R2);	// Z^[COĂAA܂Ōێ쓮[^͒~Ȃ
				break;
			default:					// LEDZT[`ɑ݂Ȃ͐M
				break;					// ȂɂȂ
			}
	}
}

//------------------------------------------------------------------------------
// R8C/34C̓Ӌ@\̏
//------------------------------------------------------------------------------
void init( void )
{
        volatile unsigned char i = 0;

        // 荞݋֎~
        DI();

        // I`bvIV[^̐ݒ
        prc0 = 1;

        fra1 = fra4;
        fra3 = fra5;
        fra2 = 0x00;
        fra00 = 1;
        while(i <= 50) i++;
        fra01 = 1;
        cm16 = 0;
        cm17 = 0;
        cm06 = 0;
        prc0 = 0;

        // I/O|[g̓o͐ݒ
        prc2 = 1;                       // pd0WX^ւ̏݋
        pd0 = 0xe0;                     // P0_0`P0_3:ZT
										// P0_4(AN3) [^[GR[_
                                        // P0_5`P0_7:LED
        prc2 = 0;                       // pd0WX^ւ̏݋֎~

        pd1 = 0xdf;                     // P1_0`P1_3:LED
                                        // P1_4:TXD0
                                        // P1_5:RXD0
										// P1_7:Servo 1:Active
		p1 = 0x00;
        pu04 = 1;
        pd2 = 0xfe;                     // P2_0:XCb`
                                        // P2_1:AIN1
                                        // P2_2:PWMA
                                        // P2_3:BIN1
                                        // P2_4:PWMB
                                        // P2_5:
                                        // P2_6:AIN2
                                        // P2_7:

        pd3 = 0xff;                     // P3_4:uU[

        pd4 = 0xfb;                     // P4_2:VREF
                                        // P4_5:BIN2

        pd6 = 0xff;                     // none

        mstcr = 0x00;                   // W[Xgbv

        // ^C}RA1ms荞ݐݒ
        tramr = 0x00;                   // JEg\[Xf1
        trapre = 128 - 1;               // vXP[
        tra = TIMER_CYCLE;              // vC}JE^
        traic = 0x01;                   // ^C}RÅ荞݃xݒ
        tracr = 0x01;                   // JEgJn

        // ^C}RB1ms荞ݐݒ
        trbmr = 0x00;                   // JEg\[Xf1
        trbpre = 128 - 1;               // vXP[
        trbpr = TIMER_CYCLE;            // vC}JE^
        trbic = 0x01;                   // ^C}RB̊荞݃xݒ
        trbcr = 0x01;                   // JEgJn

        // ^C}RCPWM[h
        trccr1 = 0xb0;                  // JEg\[Xf8
        trcgra = 0;                     // dTE_̎
        trcgrc = 0;                     // dTE_̃f[eB
        trccr2 = 0x02;                  // TRCIOC[q̓ANeBuxH
        trcoer = 0x0b;                  // TRCIOC[q̏o͋
        trcpsr1 = 0x02;                 // TRCIOC[qP3_4Ɋ蓖
        trcmr = 0x8a;                   // JEgJn

        // ^C}RD̃ZbgPWM[h
        trdpsr0 = 0x08;                 // TRDIOB0[qP2_2Ɋ蓖
        trdpsr1 = 0x45;                 // TRDIOB1[qP2_5Ɋ蓖āiSERVO_IN2j
                                        // TRDIOA1[qP2_4Ɋ蓖
										// TRDIOD1[qP2_7Ɋ蓖āiSERVO_IN1j
        trdmr = 0xf0;                   // WX^obt@ɂ
        trdfcr = 0x01;                  // ZbgPWM[hɐݒ
        trdoer1 = 0x4d;                 // TRDIOB1̏o͋
                                        // TRDIOA1̏o͋
                                        // TRDIOB0̏o͋
										// TRDIOD1̏o͋
        trdcr0 = 0x20;                  // JEg\[Xf1
        trdgra0 = trdgrc0 = PWM_CYCLE;  // 
        trdgrb0 = trdgrd0 = 0;          // TRDIOB0[qi[^j
        trdgra1 = trdgrc1 = 0;          // TRDIOA1[qiE[^j
        trdgrb1 = trdgrd1 = PWM_CYCLE/2;          // TRDIOB1[qiT[{j
        trdstr = 0x0d;                  // JEgJn

		admod   = 0x33;					// JԂ|[h
		adinsel = 0x30;                 // 8[qgp
		adcon1  = 0x30;                 // 10rbg[hAAD\
		adic 	= 0x01;					// A/D荞 D惌xF1
		adst    = 1;                    // A/DϊX^[g
		
        // 荞݋
        EI();
}




//------------------------------------------------------------------------------
// 荞
//------------------------------------------------------------------------------

volatile static unsigned short ad_result;

// encoder
// priority : 1 (Low)
#pragma interrupt intAN0 (vect=14)
void intAN0( void )
{
	static int i;
	static unsigned short ad_min = 0x03ff;	// A/Dϊs[Nl (ől)
	static unsigned short ad_max = 0;		// A/Dϊs[Nl (ŏl)
	static unsigned short ad_work = 0;		// A/Dϊ ϒlvZpϐ
	unsigned short ad_data;					// A/Dϊ ݒl
	
	if(i == 0){								// Pڂ̃f[^擾
		ad_work = ad_max = 0;				// ϐ()
		ad_min = 0x3ff;						// ϐ()
	}

	ad_data = ad3 & 0x03ff;					// A/Dϊ 擾

	ad_work += ad_data;						// ϒlvZpϐւ̉Z
	if(ad_data > ad_max){ ad_max = ad_data; }	// őlXV
	if(ad_data < ad_min){ ad_min = ad_data;	}	// ŏlXV
	i++;
	if(i >= 4){
		ad_result = (ad_work - ad_max - ad_min) >> 1;  // (4̉Z - ől - ŏl)/2
		// ܂łŁus[Nlςݕϒl(2)v
	}

	i &= 3;		// JE^ i [vp  ( 012301c ) 

}

// line censor
// cyclic handler
// priority : 2 (middle)
#pragma interrupt intTRAIC (vect=22)
void intTRAIC( void )
{
        p0_7 = ~p0_7;

        if( p0_7 == 0 ){
#if CENTER_LINE
            //p0_1Ap0_3̃j^\
            p0_5 = ~p0_1;
            p0_6 = ~p0_3;
#else
            p0_5 = p0_1;
            p0_6 = p0_3;
#endif
        }else{
#if CENTER_LINE
            //p0_0Ap0_2̃j^\
            p0_5 = p0_0;
            p0_6 = p0_2;
#else
            p0_5 = ~p0_0;
            p0_6 = ~p0_2;
#endif
        }
		line_data = sensor();
        cnt0++;
        cnt1++;
}

// servo
// priority : 3 (High)
#pragma interrupt intTRBIC (vect=24)
void intTRBIC( void )
{
	ctrl_servo(deg);	// T[{֐Ăяo
}

//------------------------------------------------------------------------------
// T[{pA/Dϊ֐
//          Ȃ
// ߂l       A/Dϊ ( s[Nlςݕϒl(2) )
//------------------------------------------------------------------------------
unsigned short get_adc(void){
	return ad_result;	// A/Dϊ ( s[Nlςݕϒl(2) ) Ԃ
}

//------------------------------------------------------------------------------
// ZT[Ԍo
//          Ȃ
// ߂l       ZTl + XVtO
//------------------------------------------------------------------------------
unsigned char sensor( void )
{
        volatile unsigned char  data1;
#if CENTER_LINE
        data1 = ~p0;                   // C̐F͔
#else
        data1 = p0;                    // C̐F͍
#endif
        data1 = data1 & 0x0f;

        data1 = data1 | 0x80;			// update flag set

        return( data1 );
}

//------------------------------------------------------------------------------
// ŐVZT[Ԍo
//          Ȃ
// ߂l       ZTl (XVtO̓NAĂ)
//------------------------------------------------------------------------------
unsigned char sensor_check( void ){
	unsigned char data;
	while( (line_data & 0x80) == 0x00 );	// update flag check
	line_data &= 0x7f;						// update flag clear
	data = line_data;			
	return data;
}

//------------------------------------------------------------------------------
// [^[x
//          [^:-100`100AE[^:-100`100
//              0Œ~A100Ő]100%A-100ŋt]100%
// ߂l       Ȃ
//------------------------------------------------------------------------------
void motor( int data1, int data2 )
{
        volatile int    motor_r;
        volatile int    motor_l;

        motor_l = (long)data1 * OPTION_L / 100;
        motor_r = (long)data2 * OPTION_R / 100;

        if( motor_l >= 0 ) {
            p2_1 = 0;
            p2_6 = 1;
            trdgrd0 = (long)( PWM_CYCLE - 1 ) * motor_l / 100;
        } else {
            p2_1 = 1;
            p2_6 = 0;
            trdgrd0 = (long)( PWM_CYCLE - 1 ) * ( -motor_l ) / 100;
        }

        if( motor_r >= 0 ) {
            p2_3 = 0;
            p4_5 = 1;
            trdgrc1 = (long)( PWM_CYCLE - 1 ) * motor_r / 100;
        } else {
            p2_3 = 1;
            p4_5 = 0;
            trdgrc1 = (long)( PWM_CYCLE - 1 ) * ( -motor_r ) / 100;
        }
}

//------------------------------------------------------------------------------
// ԉ҂
//          ^C}l 1=1ms
// ߂l       Ȃ
//------------------------------------------------------------------------------
void timer( unsigned long data1 )
{
        cnt0 = 0;
        while( cnt0 < data1 );
}

//------------------------------------------------------------------------------
// 炷
//          (1/̎g)/(1/(NbNg/8))-1
// ߂l       Ȃ
//------------------------------------------------------------------------------
void beep( int data1 )
{
        trcgra = data1;                 // ̐ݒ
        trcgrc = data1 / 2;             // f[eB50%̂ߎ̔̒l
}

//------------------------------------------------------------------------------
// vbVXCb`Ԍo
//          Ȃ
// ߂l       XCb`ĂȂꍇ:0Aꂽꍇ:1
//------------------------------------------------------------------------------
unsigned char pushsw( void )
{
        unsigned char data1;

        data1 = ~p2;
        data1 &= 0x01;

        return( data1 );
}

//------------------------------------------------------------------------------
// T[{px
//          ڕWpx
// ߂l       Ȃ
//------------------------------------------------------------------------------
void ctrl_servo(int degree)
{
#define RIGHT_MAX  		(405)						// +40x̂ƂA/Dϊ
#define LEFT_MAX   		(615)						// -40x̂ƂA/Dϊ
#define CENTER_VAL 		((LEFT_MAX+RIGHT_MAX)/2)	// }0x̂Ƃ̒l
#define GAIN       		(10)							// QC
#define ABS(x)     		(((x)>=0)?(x):-(x))

	static int ad_data = 9999;
	static int ad_data_old;
	int pos = 0;	// ݂̊px(}40x)
	int diff = 0;	// ڕW̊pxƌ݂̊px̍
	int duty = 0;	// dutywp
	
	ad_data_old = ad_data;
	ad_data = get_adc();	// T[{̏o͒l(d)擾
	pos = -((ad_data - CENTER_VAL) * 40 / ((LEFT_MAX-RIGHT_MAX)/2));	// T[{̏o͒l(d)u݊pxvɕϊ
	diff = deg - pos;		// ڕWpxƌ݊px̍vZ
	duty = ABS(diff) * GAIN + ((PWM_CYCLE)>>4);		// ɉĉ]x(duty)߂
	if(ABS(duty) >= (PWM_CYCLE/2)){
		duty = PWM_CYCLE/2 -1;
	}

	if(diff < 0){						// ڕW̊px茻݂̊pxȄꍇ
		trdgrd1 = PWM_CYCLE/2 - duty;	// duty̕ύX(ɉ)
	}
	else{								// ڕW̊px茻݂̊px̏ꍇ
		trdgrd1 = PWM_CYCLE/2 + duty;	// duty̕ύX(Eɉ)
	}
	p1_7 = 1;							// Servo Jn

	if( (ABS(diff) == 0) && ( ABS(ad_data - ad_data_old)<= 1) ){
		trdgrd1 = PWM_CYCLE/2;
		p1_7 = 0;						// Servo ~
	}
}


//------------------------------------------------------------------------------
// T[{pxݒ
//          ڕWpx
// ߂l       Ȃ
//------------------------------------------------------------------------------
void set_servo(int degree){
	deg = degree;		// ڕWpx̍XV
}


//------------------------------------------------------------------------------
// End of file
//------------------------------------------------------------------------------
